---
stages:
  - build
  - release
  - deploy
  - publish

variables:
  MAVEN_OPTS: "-Dhttps.protocols=TLSv1.2 -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true"
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true"

cache:
  paths:
    - .m2/repository

.build: &verify
  stage: build
  allow_failure: false
  only:
    - master
  except:
    variables:
      - $CI_COMMIT_MESSAGE =~ /^\[tag-ci\].*/ || $CI_COMMIT_MESSAGE =~ /^\[dev-ci\].*/
  script:
    - 'mvn ${MAVEN_CLI_OPTS} install'

verify:jdk11:
  <<: *verify
  image: registry.gitlab.com/overcoded.io/mvn:latest
